function I = incidenceMatrix(T)
%INCIDENCEMATRIX Returns the incidence matrix of the triangle mesh
% T as a sparse matrix. T is only the triangle matrix, without vertices.
n = max(T(:)); % number of vertices

r = [T(:,1); T(:,2); T(:,3)];
c = [T(:,2); T(:,3); T(:,1)];

I = sparse(r, c, 1, n ,n);
% I = I+I'; % counts edges - may be beneficial for boundary detection
I = max(I, I');


end