clear all;

load('cat7.mat');
load('results.mat');
M = struct;
M.TRIV = surface.TRIV;
M.VERT = [surface.X surface.Y surface.Z];

%% dijkstra

a = 10;
b = 10000;
[dist, path] = dijkstra(M, a, b);

figure,
trisurf(M.TRIV, M.VERT(:,1), M.VERT(:,2), M.VERT(:,3), 'EdgeAlpha', 0), axis equal, hold on, 
plot3(M.VERT(path,1), M.VERT(path,2), M.VERT(path,3), 'r'), hold on,
plot3(M.VERT(path_dij,1), M.VERT(path_dij,2), M.VERT(path_dij,3), 'b'),
legend({'height function', 'your path', 'solution path'}),

fprintf('Dijkstra: \n');
fprintf('Error: %f. \n', abs(dist_dij - dist));

%% fast marching

map = fastmarching(M, b);

figure, 
subplot(1,2,1), trisurf(M.TRIV, M.VERT(:,1), M.VERT(:,2), M.VERT(:,3), map, 'EdgeAlpha', 0), axis equal,
title('Your distance map'),
subplot(1,2,2), trisurf(M.TRIV, M.VERT(:,1), M.VERT(:,2), M.VERT(:,3), map_fm, 'EdgeAlpha', 0), axis equal, 
title('Solution distance map'),

fprintf('Fast Marching: \n')
if abs(map(a) - dist) < 5
    fprintf('The difference to your dijkstra distance between a and b is %f. It should be around 20. \n', abs(map(a) - dist))
end
fprintf('Average error: %f. If you are under 5, its a good solution. \n', sum(abs(map_fm - map))/length(M.VERT))

